package nl.cwi.sen1.error.model;

import javax.swing.tree.DefaultMutableTreeNode;

import nl.cwi.sen1.error.viewer.ErrorViewerBridge;
import nl.cwi.sen1.gui.Studio;
import errorapi.types.Error;
import errorapi.types.Summary;

public class SummaryNode extends DefaultMutableTreeNode {
	private Summary summary;

	public SummaryNode(Summary summary) {
		super(summary);
		this.summary = summary;
	}

	public Error getFirstError() {
		return summary.getList().getHead();
	}
	
	public String getProducer() {
		return summary.getProducer();
	}
	
	public String getId() {
		return summary.getId();
	}
	
	public String toString() {
		return getProducer() + " " + getId();
	}

	public void selected(Studio studio, ErrorViewerBridge bridge) {
	}
}
